# モジュール宣言/変数初期化
use strict;
my %cf;
#┌─────────────────────────────────
#│ Cosmo Navigator : init.cgi - 2022/05/14
#│ copyright (c) kentweb, 1997-2022
#│ https://www.kent-web.com/
#└─────────────────────────────────
$cf{version} = 'CosmoNavi v6.0';
#┌─────────────────────────────────
#│[ 注意事項 ]
#│ 1. このプログラムはフリーソフトです。このプログラムを使用した
#│    いかなる損害に対して作者は一切の責任を負いません。
#│ 2. 設置に関する質問はサポート掲示板にお願いいたします。メール
#│    による質問はご遠慮ください。
#└─────────────────────────────────
# REBUILD(改造)
#┌─────────────────────────────────
#│  Cosmo Navigator v6.0 PLUS 2014/05/31
#│  Edited by TRANSFORM Since 2012
#│  http://www.transformsite.com/
#└─────────────────────────────────
#===========================================================
# ■ 基本設定
#===========================================================

# naviフォルダ
# 上段：URLパス（http(s)から指定）
# 下段：サーバパス
$cf{rooturl} = 'https://www.transformsite.com/sample/data/navi6';
$cf{rootdir} = '..';

# sysディレクトリ（URLパス）（http(s)から指定）
$cf{sysurl} = 'https://www.transformsite.com/sample/data/navi6/sys';

# htmlディレクトリ【サーバパス】
$cf{htmldir} = '../html';

# 本体CGIファイル（URLパス）
$cf{navi_cgi} = "$cf{sysurl}/navi.cgi";

# 管理CGIファイル（URLパス）
$cf{admin_cgi} = "$cf{sysurl}/admin.cgi";

# 編集CGIファイル（URLパス）
$cf{edit_cgi} = "$cf{sysurl}/edit.cgi";

# データディレクトリ【サーバパス】
$cf{datadir} = './data';

# データNoファイル【サーバパス】
$cf{numfile} = "./data/num.dat";

# カウンタリセット用データ【サーバパス】
$cf{resfile} = "$cf{datadir}/reset.dat";

# ランキングカウンタデータディレクトリ【サーバパス】
$cf{rankdir} = './data/rankcnt';

# ランキングカウンタのIP重複チェックする (0=no 1=yes)
$cf{count_ipcheck} = 1;

# テンプレートディレクトリ【サーバパス】
$cf{tmpldir} = './tmpl';

# 共通ディレクトリ（URLパス）
$cf{cmnurl} = "https://www.transformsite.com/sample/data/navi6/cmn";

# 戻り先 (フルパスなら http:// から記述）
$cf{homepage} = "https://www.transformsite.com/";

# カウンタリセットのタイミング
# 0 : リセットしない
# 1 : 毎週1回 → 毎週日曜日にリセット
# 2 : 10日毎に1回 → 毎月10,20,30日にリセット
# 3 : 毎月1回 → 毎月1日にリセット
$cf{reset} = 0;

# 新着情報/人気ランキングの表示件数
$cf{new_site} = 10;
$cf{rank_site} = 20;

# 同一のURLでの登録を許可する
# 0=no 1=yes
$cf{w_url_regist} = 1;

# 同一のE-mailでの登録を許可する
# 0=no 1=yes
$cf{w_eml_regist} = 1;

#-----------------------------------------------------------
# [ 以下はバナー関連の設定 ]

# サムネイル画像を作成する（要：Image::Magick）
# → 縮小画像を自動生成し、画像記事の表示速度を軽くする機能
# 0=no 1=yes
$cf{thumbnail} = 0;
#
# バナー格納ディレクトリ【サーバパス】
$cf{upldir} = "$cf{rootdir}/banner";

# バナー格納ディレクトリ（URLパス）
$cf{uplurl} = "https://www.transformsite.com/sample/data/navi6/banner";

# リンクバナーの最大表示の大きさ（単位：ピクセル）
# → これを超える画像は縮小表示します
$cf{max_img_w} = 175;	# 横幅
$cf{max_img_h} = 35;	# 縦幅

# リンクバナーが無い場合の画像
$cf{nobanner} = 'https://www.transformsite.com/sample/data/navi6/cmn/nobanner.gif';
$cf{nobw} = '88'; #横幅
$cf{nobh} = '31'; #高さ

# アップロードを許可するファイル（0=no 1=yes）
$cf{ok_gif}   = 1;  # GIF
$cf{ok_jpeg}  = 1;  # JPEG
$cf{ok_png}   = 1;  # PNG

# 投稿受理最大サイズ (bytes)
# → 例 : 102400 = 100KB
$cf{maxdata} = 3072000;

# [ここまでがバナー関連の設定 ]
#-----------------------------------------------------------

# URLリンク部の形態
#  _self   : 現在表示されているページの中でジャンプ
#  _blank  : 別フレームを生成してそこでジャンプ
#  _top    : フレーム内であれば全てのフレームを解除してジャンプ
#  _parent : 複数フレーム内の場合１段目のみを解除してそこにジャンプ
$cf{target} = "_blank";

# ユーザ登録時メール通知
# → 0=no  1=yes
$cf{mailing} = 0;

# メール通知先アドレス（メール通知する場合）
$cf{mailto} = 'xxx@xxx.xx';

# sendmailのパス（メール通知する場合）
$cf{sendmail} = '/usr/lib/sendmail';

# sendmailの -fコマンドが必要な場合
# 0=no 1=yes
$cf{sendm_f} = 0;

# ホスト取得方法
# 0 : gethostbyaddr関数を使わない
# 1 : gethostbyaddr関数を使う
$cf{gethostbyaddr} = 0;

# 記事の更新は method=POST 限定する場合（セキュリティ対策）
# → 0=no 1=yes
$cf{postonly} = 1;

# 管理パスワードの最大間違い制限
# → この回数以上パスワードを間違うとロックします
$cf{max_failpass} = 5;

# 管理パスワードのロック期間：自動解除を日数で指定
# → この値を 0 にすると自動解除しません。
$cf{lock_days} = 14;

# -------------------------------------------------------------- #
# [ 以下は「画像認証機能」機能（スパム対策）を使用する場合の設定 ]
#
# 画像認証機能の使用
# 0 : しない
# 1 : ライブラリ版（pngren.pl）
# 2 : モジュール版（GD::SecurityImage + Image::Magick）→ Image::Magick必須
$cf{use_captcha} = 2;

# 認証用画像生成ファイル【URLパス】
$cf{captcha_cgi} = './captcha.cgi';

# 画像認証プログラム【サーバパス】
$cf{captcha_pl} = './lib/captcha.pl';
$cf{captsec_pl} = './lib/captsec.pl';
$cf{pngren_pl}  = './lib/pngren.pl';

# 画像認証機能用暗号化キー（暗号化/復号化をするためのキー）
# → 適当に変更してください。
$cf{captcha_key} = 'captchakey';

# 投稿キー許容時間（分単位）
# → 投稿フォーム表示後、送信ボタンが押されるまでの可能時間。
$cf{cap_time} = 30;

# 投稿キーの文字数
# ライブラリ版 : 4～8文字で設定
# モジュール版 : 6～8文字で設定
$cf{cap_len} = 6;

# 画像/フォント格納ディレクトリ【サーバパス】
$cf{bin_dir} = './lib/bin';

# [ライブラリ版] 画像ファイル [ ファイル名のみ ]
$cf{si_png} = "casual.png";

# [モジュール版] 画像フォント [ ファイル名のみ ]
$cf{font_ttl} = "tempest.ttf";

#===========================================================
# ■ 設定完了
#===========================================================

# 設定値を返す
sub set_init {
	open(IN,"$cf{datadir}/set.dat");
	while(<IN>) {
		chomp;
		my ($key,$val) = split(/\t/);
		
		$cf{$key} = $val;
	}
	close(IN);
	
	return %cf;
}

#-----------------------------------------------------------
#  フォームデコード
#-----------------------------------------------------------
sub parse_form {
	my $cgi = shift;

	my %in;
	foreach ( $cgi->param() ) {
		my $val = $cgi->param($_);

		if ($_ ne 'upfile') {
			# 無効化
			$val =~ s/&/&amp;/g;
			$val =~ s/"/&quot;/g;
			$val =~ s/</&lt;/g;
			$val =~ s/>/&gt;/g;

			# 改行処理
			$val =~ s/\r\n/\t/g;
			$val =~ s/[\r\n]/\t/g;
		}
		$in{$_} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  リンクバナーリサイズ
#-----------------------------------------------------------
sub resize {
	my ($w,$h) = @_;

	# 画像表示縮小
	if ($w > $cf{max_img_w} || $h > $cf{max_img_h}) {
		my $w2 = $cf{max_img_w} / $w;
		my $h2 = $cf{max_img_h} / $h;
		my $key;
		if ($w2 < $h2) { $key = $w2; } else { $key = $h2; }
		$w = int ($w * $key) || 1;
		$h = int ($h * $key) || 1;
	}

	return ($w,$h);
}

#-----------------------------------------------------------
#  日付
#-----------------------------------------------------------
sub chg_date {
	my ($time,$new) = @_;
	
	my ($sec,$min,$hour,$mday,$mon,$year,$wday,$dmy,$dmy) = localtime($time);
	my @week = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
	return $new eq 'new'
			? sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$mday,$week[$wday],$hour,$min)
			: sprintf("%04d/%02d/%02d(%s) %02d:%02d",
				$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);
}

#-----------------------------------------------------------
#  カテゴリ情報
#-----------------------------------------------------------
sub categ {
	my @categ = split(/;/,$cf{categ});
	my %cat;
	for (0 .. $#categ) {
		my @cat = split(/,/,$categ[$_]);
		
		# 大カテ
		$cat{$_}{0} = $cat[0];
		
		# 小カテ
		for my $c (1 .. $#cat) {
			$cat{$_}{$c} = $cat[$c];
		}
	}
	return %cat;
}

#-----------------------------------------------------------
#  フッター
#-----------------------------------------------------------
sub footer {
	my $foot = shift;
	
	# 著作権表記（削除・改変禁止）
	my $copy = <<EOM;
<div style="margin-top:2.6em;text-align:center;font-size:10px;">
	- <a href="https://www.kent-web.com/">$cf{version}</a> -<br />
	++ <a href="https://www.transformsite.com/" target="_top">Edited by TRANSFORM</a> ++
</div>
EOM

	my $ret;
	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		$ret .= "$1$copy$2\n";
	} else {
		$ret .= "$foot$copy\n";
		$ret .= "</body></html>\n";
	}
	return $ret;
}

#-----------------------------------------------------------
#  カテゴリプルダウン
#-----------------------------------------------------------
sub op_cate {
	my @categ = split(/;/,$cf{categ});
	my $ret;
	for (0 .. $#categ) {
		my @cat = split(/,/,$categ[$_]);
		
		$ret .= qq|<optgroup label="$cat[0]">\n|;
		for my $c (1 .. $#cat) {
			$ret .= qq|<option value="$_:$c">$cat[$c]\n|;
		}
		$ret .= qq|</optgroup>\n|;
	}
	return $ret;
}


1;

